//
//
//	Nff file lexer class
//
//											(C) 1997 JoOl



#include "LexerNff.h"



LexerNff::LexerNff(int32 BufLen, int32 LexmLen): LexerText(BufLen, LexmLen)
{
	SetCharset();
	SetLexemes();
//	PrintLexemes();
}


LexerNff::~LexerNff()
{
}


void
LexerNff::SetCharset()
{
	SetDefaultCharset();

	SetChar('-', LX_CHAR_MINUS);
	SetChar('#', LX_CHAR_COMMENT);
}


void
LexerNff::SetLexemes()
{
	AddLexeme(new Lexeme("v", LX_TOKEN_VIEW));
	AddLexeme(new Lexeme("from", LX_TOKEN_FROM));
	AddLexeme(new Lexeme("at", LX_TOKEN_AT));
	AddLexeme(new Lexeme("up", LX_TOKEN_UP));
	AddLexeme(new Lexeme("angle", LX_TOKEN_ANGLE));
	AddLexeme(new Lexeme("hither", LX_TOKEN_HITHER));
	AddLexeme(new Lexeme("resolution", LX_TOKEN_RESOLUTION));
	AddLexeme(new Lexeme("l", LX_TOKEN_LIGHT_LOCATION));
	AddLexeme(new Lexeme("b", LX_TOKEN_BACKGROUND_COLOR));
	AddLexeme(new Lexeme("f", LX_TOKEN_MATERIAL_PROPERTIES));
	AddLexeme(new Lexeme("c", LX_TOKEN_CYLINDER));
	AddLexeme(new Lexeme("s", LX_TOKEN_SPHERE));
	AddLexeme(new Lexeme("p", LX_TOKEN_POLYGON));
	AddLexeme(new Lexeme("pp", LX_TOKEN_POLYGON_PATCH));
	SortLexemes();
}


bool
LexerNff::SetInput(entry_ref& Ref)
{
	return inherited::SetInput(Ref);
}



bool
LexerNff::NextToken(uint32& Out)
{
	InitNextToken();

	// This loop is exited when a lexeme is found
	for (;;)
	{
		if (EndOfFile)
		{
			Out = Token = LX_CHAR_EOF;
			return true;
		}

		LexmStart = LexmEnd;
		uint8			CharType = Charset[uint8(*LexmEnd)];

		if ((CharType == LX_CHAR_DIGIT) || (*LexmEnd == '.'))
		{
			if (!LexNumber())
				return false;
			Out = Token;
			return true;
		}
		else if (CharType == LX_CHAR_ALPHA)
		{
			if (!LexString())
				return false;
			Out = Token;
			return true;
		}
		else if (CharType == LX_CHAR_MINUS)
		{
			FWD;
			if (!LexNumber())
				return false;
			Out = Token;
			return true;
		}
		else if (CharType == LX_CHAR_SPACE)
		{
			if (!SkipSpaces())
				return false;
		}
		else if (CharType == LX_CHAR_COMMENT)
		{
			if (!SkipLine())
				return false;
		}
		else if (CharType == LX_CHAR_ILLEGAL)	// Illegal characters generate an error
		{
			Out = Token = LX_CHAR_ILLEGAL;
			return false;
		}
		else		// lexeme?
		{
			Out = Token = CharType;
			FWD;
			return true;
		}
	}
}
