//
//
//	Obj file lexer class
//
//											(C) 1997 JoOl


#ifndef _OBJ_LEXER_H_
#define _OBJ_LEXER_H_

#include "LexerText.h"


enum
{
	LX_CHAR_COMMENT = LX_CHAR_LAST+1,
	LX_CHAR_SLASH
};


// Tokens in OBJ files
enum
{
	// Vertex data
	LX_TOKEN_V = 0x100,
	LX_TOKEN_VTEXTURE,			// Vertex texture coordinates
	LX_TOKEN_VNORMAL,			// Vertex normal
	LX_TOKEN_VPARAM,			// Parameter space vertex
	LX_TOKEN_CSTYPE,			// Curve or Surface type
		LX_TOKEN_RAT,			// Indicate rational curves or surfaces
		LX_TOKEN_BMATRIX,		// Curce or surface type
		LX_TOKEN_BEZIER,
		LX_TOKEN_BSPLINE,
		LX_TOKEN_CARDINAL,
		LX_TOKEN_TAYLOR,
	LX_TOKEN_DEGREE,			// degree

	LX_TOKEN_BMATU,				// Basis matrix u
	LX_TOKEN_BMATV,				// Basis matrix v
	LX_TOKEN_STEP,				// Step size

	// Elements
	LX_TOKEN_POINT,
	LX_TOKEN_LINE,
	LX_TOKEN_FACE,
	LX_TOKEN_CURVE,
	LX_TOKEN_CURVE2D,
	LX_TOKEN_SURFACE,

	// Free-form curve/surface body statements
	LX_TOKEN_PARAMU,			// parameter values u
	LX_TOKEN_PARAMV,			// parameter values v
	LX_TOKEN_TRIM,				// outer trimming loop
	LX_TOKEN_HOLE,				// inner trimming loop
	LX_TOKEN_SCURVE,			// special curve
	LX_TOKEN_SPOINT,			// special point
	LX_TOKEN_ENDSTMT,			// end statement

	// Connectivity between free-form surfaces
	LX_TOKEN_CONNECT,

	// Grouping
	LX_TOKEN_GROUPNAME,
	LX_TOKEN_SMOOTHGROUP,
	LX_TOKEN_MERGEGROUP,
	LX_TOKEN_OBJECTNAME,

	// Display/render attributes
	LX_TOKEN_BEVELINTERP,		// Bevel interpolation

	LX_TOKEN_CINTERP,			// Color interpolation
	LX_TOKEN_DINTERP,			// Dissolve interpolation

	LX_TOKEN_LOD,				// Level of detail
	LX_TOKEN_MAPLIB,
	LX_TOKEN_USEMAP,
	LX_TOKEN_USEMATERIAL,
	LX_TOKEN_MATLIB,
	LX_TOKEN_SHADOW,			// Shadow casting
	LX_TOKEN_TRACE,				// Raytracing

	LX_TOKEN_CTECH,				// Curve approximation technique
	LX_TOKEN_STECH,				// Surface approx technique
		LX_TOKEN_CPARM,
		LX_TOKEN_CSPACE,
		LX_TOKEN_CPARMA,
		LX_TOKEN_CPARMB,

	LX_TOKEN_BSP,
	LX_TOKEN_BZP,
	LX_TOKEN_CDC,
	LX_TOKEN_CDP,
	LX_TOKEN_RES
};



class					LexerObj : public LexerText
{
	void				SetCharset();
	void				SetLexemes();

public:

	LexerObj(int32, int32);
	~LexerObj();

	virtual bool		NextToken(uint32& );
};



#endif	/* _OBJ_LEXER_H_ */

