//
//
//	Text file lexer class
//
//											(C) 1997 JoOl


#ifndef _TEXT_LEXER_H_
#define _TEXT_LEXER_H_


#include "Lexer.h"
#include "Lexeme.h"



class						LexerText : public Lexer
{
	BList					Lexemes;

	uint32					LineNumber;

	static int				CmpLexemes(const void* l1, const void* l2);

protected:

#pragma export on

	void					InitNextToken();
	static bool				PrintLexeme(void* L);

	uint32					Token;
	uValue					TokenValue;

	char					IllegalCharacter;

public:

	LexerText(int32, int32);
	~LexerText();

	int32					RankOfLexeme(char* );
	Lexeme*					SearchLexeme(char* );
	bool					AddLexeme(Lexeme* );
	void					SortLexemes();
	void					PrintLexemes();

	const char*				GetTokenLexeme(uint32);

	int32					GetTokenValueInt()
	{ return TokenValue.Int;	};
	float					GetTokenValueFloat()
	{ return TokenValue.Float;	};
	char*					GetTokenValueStr()
	{ return TokenValue.Str;	};

	uint32					GetLineNumber()
	{ return LineNumber;	};

	char					GetIllegalCharacter()
	{ return IllegalCharacter;	};

	virtual bool			SetInput(entry_ref&);

	bool					SkipSpaces();
	bool					SkipLine();

	bool					LexWord();
	bool					LexNumber();		// integer or float
	bool					LexString();

	virtual bool			NextToken(uint32 &);


#pragma export off

};


#endif	/* _TEXT_LEXER_H_ */

